## xmount 0.7.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(xmount C)

include(CheckIncludeFiles)
#include(CheckCSourceCompiles)

# Only for internal packaging
#set(STATIC 1)
if(STATIC)
  set(STATIC_EWF 1)
  set(STATIC_AFF 1)
endif(STATIC)

add_definitions(-DXMOUNT_VERSION="0.7.2")

if(APPLE)
  # On OSx, do not try to find frameworks but only std headers / libraries
  set(CMAKE_FIND_FRAMEWORK "NEVER")
endif(APPLE)

# Make sure CMAKE_BUILD_TYPE is set
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
else(NOT CMAKE_BUILD_TYPE)
  if(NOT (CMAKE_BUILD_TYPE STREQUAL "Release" OR
          CMAKE_BUILD_TYPE STREQUAL "Debug"))
    message(FATAL_ERROR "Only build types 'Release' and 'Debug' are supported!")
  endif(NOT (CMAKE_BUILD_TYPE STREQUAL "Release" OR
             CMAKE_BUILD_TYPE STREQUAL "Debug"))
endif(NOT CMAKE_BUILD_TYPE)

# Add cmake_modules dir to CMAKE_MODULE_PATH
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake_modules/")

# Check required headers
check_include_files(stdlib.h HAVE_STDLIB_H)
check_include_files(stdio.h HAVE_STDIO_H)
check_include_files(stdint.h HAVE_STDINT_H)
check_include_files(stdarg.h HAVE_STDARG_H)
check_include_files(string.h HAVE_STRING_H)
check_include_files(errno.h HAVE_ERRNO_H)
check_include_files(fcntl.h HAVE_FCNTL_H)
check_include_files(dlfcn.h HAVE_DLFCN_H)
check_include_files(dirent.h HAVE_DIRENT_H)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(sys/ioctl.h HAVE_SYS_IOCTL_H)
check_include_files(sys/stat.h HAVE_SYS_STAT_H)
check_include_files(sys/types.h HAVE_SYS_TYPES_H)
check_include_files(linux/fs.h HAVE_LINUX_FS_H)
check_include_files(grp.h HAVE_GRP_H)
check_include_files(pwd.h HAVE_PWD_H)
check_include_files(pthread.h HAVE_PTHREAD_H)
check_include_files(time.h HAVE_TIME_H)
check_include_files(inttypes.h HAVE_INTTYPES_H)
check_include_files(byteswap.h HAVE_BYTESWAP_H)
check_include_files(endian.h HAVE_ENDIAN_H)
check_include_files(libkern/OSByteOrder.h HAVE_LIBKERN_OSBYTEORDER_H)

# Check for required libs
if(NOT APPLE)
  find_package(LibFUSE REQUIRED)
else(NOT APPLE)
  # On OSx, search for osxfuse
  find_package(LibOSXFUSE REQUIRED)
endif(NOT APPLE)

# Generate config.h and add it's path to the include dirs
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# Add preprocessor definitions
add_definitions(-D_LARGEFILE64_SOURCE)
add_definitions(-D_FILE_OFFSET_BITS=64)
add_definitions(-D_GNU_SOURCE)
set(CMAKE_C_FLAGS "-fno-strict-aliasing -std=c99 -Wall")
set(CMAKE_C_FLAGS_RELEASE "-O2 ${CMAKE_C_FLAGS}")
set(CMAKE_C_FLAGS_DEBUG "-ggdb -O0 ${CMAKE_C_FLAGS}")

# Check that off_t can represent 2**63 - 1 correctly.
# If it can't, we need to set _FILE_OFFSET_BITS=64
#check_c_source_compiles("
#  #include <sys/types.h>
#  #define LARGE_OFF_T (((off_t) 1 << 62) - 1 + ((off_t) 1 << 62))
#  int off_t_is_large[(LARGE_OFF_T % 2147483629 == 721 && LARGE_OFF_T % 2147483647 == 1) ? 1 : -1];
#  int main() { return 0; }
#" _OFFT_IS_64BIT)
#if(NOT ${_OFFT_IS_64BIT})
#  set(CMAKE_C_FLAGS ${CMAKE_C_FLAGS} "-D_FILE_OFFSET_BITS=64")
#endif(NOT ${_OFFT_IS_64BIT})

# Compile stuff in sub dirs
add_subdirectory(libxmount_input)
add_subdirectory(libxmount_morphing)
add_subdirectory(src)

# Install man page
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/xmount.1 DESTINATION share/man/man1)

=== libxmount_morphing/libxmount_morphing_combine/CMakeLists.txt ===
if(POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW) # CMake 3.0
endif(POLICY CMP0042)

project(libxmount_morphing_combine C)

add_library(xmount_morphing_combine SHARED libxmount_morphing_combine.c)

install(TARGETS xmount_morphing_combine DESTINATION lib/xmount)

=== debian/changelog ===
xmount (0.7.2-1) unstable; urgency=medium

  * [08ccc6f] Import new upstream release 0.7.2
  * [38e0799] Replace Build-Dependency on libgnutls-dev with
    libgnutls28-dev
  * [a878bc5] Bump Standards-Version to 3.9.6
  * [90262c7] Run wrap-and-sort on the debian directory
  * [460f877] Replace auto{conf,make} with cmake, add zlib1g-dev as Build-
    Dependency
  * [6f15d8e] Bump debian/compat version to 9 + Build-Depend on debhelper
    >=9
  * [b64906d] Add debian/source/format
  * [f851545] Update debian/copyright for new release
  * [38fca30] Enable Hardening using hardening-wrapper

 -- Michael Prokop <mika@debian.org>  Thu, 02 Oct 2014 13:17:50 +0200

xmount (0.5.0-3) unstable; urgency=low

  * [cc92503] Adjust configure* for new libewf version 20130416-2
  * [4d80734] Bump Standards-Version to 3.9.4
  * [c725434] Add libbfio-dev to Build-Depends

 -- Michael Prokop <mika@debian.org>  Mon, 22 Jul 2013 14:07:06 +0200

xmount (0.5.0-2) unstable; urgency=low

  * [3d6c4cd] Switch to debhelper7 minimal style and adjust
    Build-Depends and compat version accordingly
  * [5402096] Use Architecture: linux-any due to linux/fs.h being
    linux-only. Thanks to Ulrich Dangel + Axel Beckert for
    help in verification

 -- Michael Prokop <mika@debian.org>  Tue, 12 Jun 2012 00:24:19 +0200

xmount (0.5.0-1) unstable; urgency=low

  * [1db6447] Merging upstream version 0.5.0
  * [200b105] Bump Standards-Version to 3.9.3.
  * [bfe7926] Drop duplicated libfuse-dev Build-Depends
  * [b66fd49] Update package description to match latest upstream
    development
  * [8c947ea] Transfer copyright file into dep5 format
  * [0038ca1] Add build-arch/build-indep targets
  * [da5bc8c] Call autoreconf before configure

 -- Michael Prokop <mika@debian.org>  Mon, 11 Jun 2012 20:13:42 +0200

xmount (0.4.5-1) unstable; urgency=low

  * [5ec3492] Merging upstream version 0.4.5.
  * [feac9cb] Bump Standards-Version to 3.9.2.
  * [eb93b4a] Add libafflib-dev to Build-Depends.
  * [e44de3b] Add pkg-config to Build-Depends.
  * [3c16a7f] Add libfuse-dev to Build-Depends.

 -- Michael Prokop <mika@debian.org>  Fri, 24 Jun 2011 23:42:33 +0200

xmount (0.4.4-1) unstable; urgency=low

  * [7c86bed] Merge new upstream version 0.4.4.
  * [6a5c49e] Bump Standards-Version to 3.9.1.
  * [7e1ac4b] Add libgnutls-dev to Build-Depends.

 -- Michael Prokop <mika@debian.org>  Wed, 16 Feb 2011 15:11:51 +0100

xmount (0.3.3-1) unstable; urgency=low

  * New upstream version 0.3.3 (being a bugfix release addressing the
    "fopen64 implicitly converted to pointer" issue). [Closes: #542234]
    Thanks to Dann Frazier for the bugreport.
  * Bump Standard-Version to 3.8.3 (no further changes).

 -- Michael Prokop <mika@debian.org>  Wed, 19 Aug 2009 01:27:51 +0200

xmount (0.3.2-1) unstable; urgency=low

  * New upstream version 0.3.2.
  * Slightly adjust package long description and copyright file.

 -- Michael Prokop <mika@debian.org>  Tue, 28 Jul 2009 11:13:04 +0200

xmount (0.3.1-1) unstable; urgency=low

  * Initial release. [Closes: #536493]
  * Packaging based on work by upstream author,
    Gillen Daniel <gillen.dan@pinguin.lu>.

 -- Michael Prokop <mika@debian.org>  Fri, 10 Jul 2009 12:25:11 +0200

=== debian/control ===
Source: xmount
Section: admin
Priority: optional
Maintainer: Michael Prokop <mika@debian.org>
Build-Depends: cmake,
               debhelper (>= 9),
               hardening-wrapper,
               libafflib-dev,
               libbfio-dev,
               libewf-dev (>= 20080501),
               libfuse-dev (>= 2.7.1-2~bpo40+1),
               libgnutls28-dev,
               pkg-config,
               zlib1g-dev
Standards-Version: 3.9.6
Homepage: https://www.pinguin.lu/
Vcs-git: git://git.grml.org/xmount.git
Vcs-Browser: http://git.grml.org/?p=xmount.git

Package: xmount
Architecture: linux-any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: tool to crossmount between multiple input and output harddisk images
 xmount allows you to convert on-the-fly between multiple input
 and output harddisk image types. xmount creates a virtual file
 system using FUSE (Filesystem in Userspace) that contains a
 virtual representation of the input harddisk image. The virtual
 representation can be in raw DD, VirtualBox's virtual disk file
 (VDI) format, Microsoft's Virtual Hard Disk Image format (VHD)
 or in VMware's VMDK format. Input harddisk images can be raw DD
 or EWF (Expert Witness Compression Format) or AFF (Advanced
 Forensic Format) files. In addition, xmount also supports
 virtual write access to the output files that is redirected to a
 cache file. This makes it for example possible to boot acquired
 harddisk images using QEMU, KVM, VirtualBox, VMware or alike.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_HARDENING=1

%:
	dh $@

override_dh_auto_configure:
	cmake -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr

## xmount 0.7.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
   set(STATIC_AFF 1)
 endif(STATIC)
 
-add_definitions(-DXMOUNT_VERSION="0.7.2")
+add_definitions(-DXMOUNT_VERSION="0.7.3")
 
 if(APPLE)
   # On OSx, do not try to find frameworks but only std headers / libraries

=== libxmount_input/CMakeLists.txt ===
add_subdirectory(libxmount_input_raw)

if(NOT STATIC_EWF)
  find_package(LibEWF)
  if(LIBEWF_FOUND)
    add_subdirectory(libxmount_input_ewf)
  endif(LIBEWF_FOUND)
else(NOT STATIC_EWF)
  message(STATUS "Not checking for LibEWF (STATIC_EWF = 1)")
  add_subdirectory(libxmount_input_ewf)
endif(NOT STATIC_EWF)

if(NOT STATIC_AFF)
  find_package(LibAFF)
  if(LIBAFF_FOUND)
    add_subdirectory(libxmount_input_aff)
  endif(LIBAFF_FOUND)
else(NOT STATIC_AFF)
  message(STATUS "Not checking for LibAFF (STATIC_AFF = 1)")
  add_subdirectory(libxmount_input_aff)
endif(NOT STATIC_AFF)

find_package(LibZ)
if(LIBZ_FOUND)
  add_subdirectory(libxmount_input_aewf)
  add_subdirectory(libxmount_input_aaff)
endif(LIBZ_FOUND)

=== src/CMakeLists.txt ===
if(NOT APPLE)
  include_directories(${LIBFUSE_INCLUDE_DIRS})
  set(LIBS ${LIBS} ${LIBFUSE_LIBRARIES})
else(NOT APPLE)
  include_directories(${LIBOSXFUSE_INCLUDE_DIRS})
  set(LIBS ${LIBS} ${LIBOSXFUSE_LIBRARIES})
endif(NOT APPLE)

set(LIBS ${LIBS} "dl")

add_definitions(-DXMOUNT_LIBRARY_PATH="${CMAKE_INSTALL_PREFIX}/lib/xmount")

add_executable(xmount xmount.c md5.c ../libxmount/libxmount.c)

target_link_libraries(xmount ${LIBS})

install(TARGETS xmount DESTINATION bin)

=== libxmount_input/libxmount_input_aaff/CMakeLists.txt ===
if(POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW) # CMake 3.0
endif(POLICY CMP0042)

project(libxmount_input_aaff C)

add_library(xmount_input_aaff SHARED libxmount_input_aaff.c ../../libxmount/libxmount.c)
include_directories(${LIBZ_INCLUDE_DIRS})

target_link_libraries(xmount_input_aaff ${LIBZ_LIBRARIES})

install(TARGETS xmount_input_aaff DESTINATION lib/xmount)

=== libxmount_input/libxmount_input_aewf/CMakeLists.txt ===
if(POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW) # CMake 3.0
endif(POLICY CMP0042)

project(libxmount_input_aewf C)

add_library(xmount_input_aewf SHARED libxmount_input_aewf.c ../../libxmount/libxmount.c)

include_directories(${LIBZ_INCLUDE_DIRS})

target_link_libraries(xmount_input_aewf ${LIBZ_LIBRARIES})

install(TARGETS xmount_input_aewf DESTINATION lib/xmount)

=== libxmount_input/libxmount_input_aff/CMakeLists.txt ===
if(POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW) # CMake 3.0
endif(POLICY CMP0042)

project(libxmount_input_aff C)

add_library(xmount_input_aff SHARED libxmount_input_aff.c)

if(NOT STATIC_AFF)
  include_directories(${LIBAFF_INCLUDE_DIRS})
  include_directories(${OPENSSL_INCLUDE_DIRS})
  set(LIBS ${LIBS} ${LIBAFF_LIBRARIES})
  set(LIBS ${LIBS} ${OPENSSL_LIBRARIES})
else(NOT STATIC_AFF)
  add_definitions(-DHAVE_LIBAFF_STATIC)
  include_directories(${CMAKE_CURRENT_SOURCE_DIR}/libaff/lib)
  set(LIBS ${LIBS} ${CMAKE_CURRENT_SOURCE_DIR}/libaff/lib/.libs/libafflib.a)
  if(NOT APPLE)
    set(LIBS ${LIBS} "/usr/lib/libcrypto.a")
    set(LIBS ${LIBS} "/usr/lib/libssl.a")
    set(LIBS ${LIBS} "/usr/lib/libexpat.a")
    set(LIBS ${LIBS} "/usr/lib/librt.a")
    set(LIBS ${LIBS} "-lstdc++ -lz")
  else(NOT APPLE)
    # As most of afflib's deps on OSx come from MacPorts, better link in
    # everything statically
    set(LIBS ${LIBS} "/opt/local/lib/libcrypto.a")
    set(LIBS ${LIBS} "/opt/local/lib/libssl.a")
    set(LIBS ${LIBS} "/opt/local/lib/libexpat.a")
    set(LIBS ${LIBS} "/opt/local/lib/libncurses.a")
    set(LIBS ${LIBS} "/opt/local/lib/libreadline.a")
    set(LIBS ${LIBS} "/opt/local/lib/libz.a")
    set(LIBS ${LIBS} "-lstdc++")
  endif(NOT APPLE)
endif(NOT STATIC_AFF)

target_link_libraries(xmount_input_aff ${LIBS})

install(TARGETS xmount_input_aff DESTINATION lib/xmount)

=== libxmount_input/libxmount_input_ewf/CMakeLists.txt ===
if(POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW) # CMake 3.0
endif(POLICY CMP0042)

project(libxmount_input_ewf C)

add_library(xmount_input_ewf SHARED libxmount_input_ewf.c)

if(NOT STATIC_EWF)
  include_directories(${LIBEWF_INCLUDE_DIRS})
  set(LIBS ${LIBS} ${LIBEWF_LIBRARIES})
else(NOT STATIC_EWF)
  add_definitions(-DHAVE_LIBEWF_STATIC)
  include_directories(${CMAKE_CURRENT_SOURCE_DIR}/libewf/include)
  set(LIBS ${LIBS} ${CMAKE_CURRENT_SOURCE_DIR}/libewf/libewf/.libs/libewf.a)
  if(NOT APPLE)
    set(LIBS ${LIBS} "-lz")
  else(NOT APPLE)
    # As most of libewf's deps on OSx come from MacPorts, better link in
    # everything statically
    set(LIBS ${LIBS} "/opt/local/lib/libz.a")
  endif(NOT APPLE)
endif(NOT STATIC_EWF)

target_link_libraries(xmount_input_ewf ${LIBS})

install(TARGETS xmount_input_ewf DESTINATION lib/xmount)

=== debian/changelog ===
xmount (0.7.3-1build2) bionic; urgency=high

  * No change rebuild to pick up -fPIE compiler default

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 03 Apr 2018 12:52:49 +0000

xmount (0.7.3-1build1) wily; urgency=medium

  * No-change rebuild against libafflib0v5.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 12 Aug 2015 09:11:27 +0200

xmount (0.7.3-1) unstable; urgency=medium

  * [adaf426] Imported new upstream release 0.7.3
  * [696333b] Update Vcs-* headers after moving package to forensics group
  * [a5c3fed] Drop Build-Depends on hardening-wrapper
  * [9db2efc] Enable hardening feature via debian/rules
  * [1674627] New debian patch to support overwriting CMAKE_C_FLAGS for
    hardening support

 -- Michael Prokop <mika@debian.org>  Fri, 03 Jul 2015 01:49:45 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: xmount
 Section: admin
 Priority: optional
-Maintainer: Michael Prokop <mika@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Michael Prokop <mika@debian.org>
 Build-Depends: cmake,
                debhelper (>= 9),
-               hardening-wrapper,
                libafflib-dev,
                libbfio-dev,
                libewf-dev (>= 20080501),
@@ -14,8 +14,8 @@
                zlib1g-dev
 Standards-Version: 3.9.6
 Homepage: https://www.pinguin.lu/
-Vcs-git: git://git.grml.org/xmount.git
-Vcs-Browser: http://git.grml.org/?p=xmount.git
+Vcs-Browser: https://anonscm.debian.org/cgit/forensics/xmount.git
+Vcs-Git: git://anonscm.debian.org/forensics/xmount.git
 
 Package: xmount
 Architecture: linux-any

=== debian/rules ===
--- 
+++ 
@@ -9,10 +9,10 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-export DEB_BUILD_HARDENING=1
+CMAKE_C_FLAGS:=$(shell dpkg-buildflags --get CPPFLAGS) -fno-strict-aliasing -std=c99 -Wall
 
 %:
 	dh $@
 
 override_dh_auto_configure:
-	cmake -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr
+	cmake -DCMAKE_C_FLAGS="$(CMAKE_C_FLAGS)" -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr

## xmount 0.7.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,14 +4,26 @@
 include(CheckIncludeFiles)
 #include(CheckCSourceCompiles)
 
-# Only for internal packaging
+# Only for internal packaging only
 #set(STATIC 1)
 if(STATIC)
   set(STATIC_EWF 1)
   set(STATIC_AFF 1)
 endif(STATIC)
 
-add_definitions(-DXMOUNT_VERSION="0.7.3")
+if(STATIC_AFF)
+  if(NOT LINUX_DIST)
+    set(LINUX_DIST "debian7")
+  else(NOT LINUX_DIST)
+    if(NOT (LINUX_DIST STREQUAL "debian7" OR
+            LINUX_DIST STREQUAL "rhel7"))
+      message(FATAL_ERROR "Only Linux dists 'debian7' and 'rhel7' are supported!")
+    endif(NOT (LINUX_DIST STREQUAL "debian7" OR
+               LINUX_DIST STREQUAL "rhel7"))
+  endif(NOT LINUX_DIST)
+endif(STATIC_AFF)
+
+add_definitions(-DXMOUNT_VERSION="0.7.6")
 
 if(APPLE)
   # On OSx, do not try to find frameworks but only std headers / libraries

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,7 @@
 else(NOT APPLE)
   include_directories(${LIBOSXFUSE_INCLUDE_DIRS})
   set(LIBS ${LIBS} ${LIBOSXFUSE_LIBRARIES})
+  link_directories(${LIBOSXFUSE_LIBRARY_DIRS})
 endif(NOT APPLE)
 
 set(LIBS ${LIBS} "dl")

=== libxmount_input/libxmount_input_aff/CMakeLists.txt ===
--- 
+++ 
@@ -16,10 +16,35 @@
   include_directories(${CMAKE_CURRENT_SOURCE_DIR}/libaff/lib)
   set(LIBS ${LIBS} ${CMAKE_CURRENT_SOURCE_DIR}/libaff/lib/.libs/libafflib.a)
   if(NOT APPLE)
-    set(LIBS ${LIBS} "/usr/lib/libcrypto.a")
-    set(LIBS ${LIBS} "/usr/lib/libssl.a")
-    set(LIBS ${LIBS} "/usr/lib/libexpat.a")
-    set(LIBS ${LIBS} "/usr/lib/librt.a")
+    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
+      # 64bit
+      if(LINUX_DIST STREQUAL "debian7")
+        set(LIBS ${LIBS} "/usr/lib/x86_64-linux-gnu/libcrypto.a")
+        set(LIBS ${LIBS} "/usr/lib/x86_64-linux-gnu/libssl.a")
+        set(LIBS ${LIBS} "/usr/lib/x86_64-linux-gnu/libexpat.a")
+        set(LIBS ${LIBS} "/usr/lib/x86_64-linux-gnu/librt.a")
+      endif(LINUX_DIST STREQUAL "debian7")
+      if(LINUX_DIST STREQUAL "rhel7")
+        set(LIBS ${LIBS} "/usr/lib64/libcrypto.a")
+        set(LIBS ${LIBS} "/usr/lib64/libssl.a")
+        set(LIBS ${LIBS} "/usr/lib64/libexpat.a")
+        set(LIBS ${LIBS} "/usr/lib64/librt.a")
+      endif(LINUX_DIST STREQUAL "rhel7")
+    else(CMAKE_SIZEOF_VOID_P EQUAL 8)
+      # 32bit
+      if(LINUX_DIST STREQUAL "debian7")
+        set(LIBS ${LIBS} "/usr/lib/i386-linux-gnu/libcrypto.a")
+        set(LIBS ${LIBS} "/usr/lib/i386-linux-gnu/libssl.a")
+        set(LIBS ${LIBS} "/usr/lib/i386-linux-gnu/libexpat.a")
+        set(LIBS ${LIBS} "/usr/lib/i386-linux-gnu/librt.a")
+      endif(LINUX_DIST STREQUAL "debian7")
+      if(LINUX_DIST STREQUAL "rhel7")
+        set(LIBS ${LIBS} "/usr/lib/libcrypto.a")
+        set(LIBS ${LIBS} "/usr/lib/libssl.a")
+        set(LIBS ${LIBS} "/usr/lib/libexpat.a")
+        set(LIBS ${LIBS} "/usr/lib/librt.a")
+      endif(LINUX_DIST STREQUAL "rhel7")
+    endif(CMAKE_SIZEOF_VOID_P EQUAL 8)
     set(LIBS ${LIBS} "-lstdc++ -lz")
   else(NOT APPLE)
     # As most of afflib's deps on OSx come from MacPorts, better link in

=== debian/changelog ===
xmount (0.7.6-3) unstable; urgency=medium

  * Team Upload

  [ Michael Prokop ]
  * Improve Debian package description.
    Thanks to Justin B Rye and Xavier Brochard (Closes: #927968)

  [ Samuel Henrique ]
  * Bump DH to 13
  * Bump Standards-Version to 4.5.1
  * Bump d/watch to v4
  * Add salsa-ci.yml
  * Configure git-buildpackage for Debian
  * d/control: Add 'Rules-Requires-Root: no'
  * d/rules: Export 'export DEB_BUILD_MAINT_OPTIONS = hardening=+all'

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.

 -- Samuel Henrique <samueloph@debian.org>  Sun, 31 Jan 2021 23:48:59 +0000

xmount (0.7.6-2) unstable; urgency=medium

  * Team upload.
  * Rely on dh_auto_configure instead of hardcoded cmake call
    to make the package cross-buildable.
    Thanks to Helmut Grohne <helmut@subdivi.de> (Closes: #884728)
  * Bump Standards-Version to 4.2.1 and debhelper compat level to 11
  * Build the package with debug symbols and pass LDFLAGS properly.
  * Improve copyright file (put separate license paragraph for GPL-3+)
  * Add a watch file.

 -- Raphaël Hertzog <hertzog@debian.org>  Sun, 02 Sep 2018 14:00:15 +0200

xmount (0.7.6-1) unstable; urgency=medium

  [ Raphaël Hertzog ]
  * [2da76cf] Add pkg-security team to Uploaders
  * [b1d6089] Update Vcs-Git and Vcs-Browser for the move to
    salsa.debian.org

  [ Michael Prokop ]
  * [65d2fb3] New upstream version 0.7.6

 -- Michael Prokop <mika@debian.org>  Fri, 18 May 2018 13:37:55 +0200

=== debian/control ===
Source: xmount
Section: admin
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders:
 Michael Prokop <mika@debian.org>,
Build-Depends: cmake,
               debhelper-compat (= 13),
               libafflib-dev,
               libbfio-dev,
               libewf-dev (>= 20080501),
               libfuse-dev (>= 2.7.1-2~bpo40+1),
               libgnutls28-dev,
               pkg-config,
               zlib1g-dev
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://www.pinguin.lu/
Vcs-Browser: https://salsa.debian.org/pkg-security-team/xmount
Vcs-Git: https://salsa.debian.org/pkg-security-team/xmount.git

Package: xmount
Architecture: linux-any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: tool for crossmounting between disk image formats
 xmount can be used to boot forensic disk images with QEMU, KVM,
 VirtualBox, VMware, or the like, since it supports virtual write
 access with redirection to a cache file.
 .
 xmount converts between multiple input and output disk image types
 on the fly, using FUSE (Filesystem in Userspace) to create a virtual
 file system representing the input image. The virtual representation
 can be in raw DD, DMG, VirtualBox VDI format, Microsoft VHD format, or
 VMware VMDK format; input images can be raw DD, EWF (Expert Witness
 Compression Format), or AFF (Advanced Forensic Format) files.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CMAKE_C_FLAGS:=$(shell dpkg-buildflags --get CPPFLAGS) -g -fno-strict-aliasing -std=c99 -Wall
CMAKE_LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_C_FLAGS="$(CMAKE_C_FLAGS)" -DCMAKE_BUILD_TYPE=Release -DCMAKE_SHARED_LINKER_FLAGS="$(CMAKE_LDFLAGS)" -DCMAKE_EXE_LINKER_FLAGS="$(CMAKE_LDFLAGS)" -DCMAKE_MODULE_LINKER_FLAGS="$(CMAKE_LDFLAGS)"

=== debian/watch ===
version=4
https://www.pinguin.lu/xmount \
    .*/xmount-@ANY_VERSION@@ARCHIVE_EXT@

## xmount 1.1.1

=== CMakeLists.txt ===
# Copyright 2019 Google Inc. All Rights Reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following disclaimer
# in the documentation and/or other materials provided with the
# distribution.
#     * Neither the name of Google Inc. nor the names of its
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.1)
project(Snappy VERSION 1.1.10 LANGUAGES C CXX)

# C++ standard can be overridden when this is used as a sub-project.
if(NOT CMAKE_CXX_STANDARD)
  # This project requires C++11.
  set(CMAKE_CXX_STANDARD 11)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
  set(CMAKE_CXX_EXTENSIONS OFF)
endif(NOT CMAKE_CXX_STANDARD)

# https://github.com/izenecloud/cmake/blob/master/SetCompilerWarningAll.cmake
if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  # Use the highest warning level for Visual Studio.
  set(CMAKE_CXX_WARNING_LEVEL 4)
  if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
    string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  else(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
  endif(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")

  # Disable C++ exceptions.
  string(REGEX REPLACE "/EH[a-z]+" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHs-c-")
  add_definitions(-D_HAS_EXCEPTIONS=0)

  # Disable RTTI.
  string(REGEX REPLACE "/GR" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /GR-")
else(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  # Use -Wall for clang and gcc.
  if(NOT CMAKE_CXX_FLAGS MATCHES "-Wall")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
  endif(NOT CMAKE_CXX_FLAGS MATCHES "-Wall")

  # Use -Wextra for clang and gcc.
  if(NOT CMAKE_CXX_FLAGS MATCHES "-Wextra")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra")
  endif(NOT CMAKE_CXX_FLAGS MATCHES "-Wextra")

  # Use -Werror for clang only.
  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    if(NOT CMAKE_CXX_FLAGS MATCHES "-Werror")
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
    endif(NOT CMAKE_CXX_FLAGS MATCHES "-Werror")
  endif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")

  # Disable C++ exceptions.
  string(REGEX REPLACE "-fexceptions" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")

  # Disable RTTI.
  string(REGEX REPLACE "-frtti" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti")
endif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")

# BUILD_SHARED_LIBS is a standard CMake variable, but we declare it here to make
# it prominent in the GUI.
option(BUILD_SHARED_LIBS "Build shared libraries(DLLs)." OFF)

option(SNAPPY_BUILD_TESTS "Build Snappy's own tests." ON)

option(SNAPPY_BUILD_BENCHMARKS "Build Snappy's benchmarks" ON)

option(SNAPPY_FUZZING_BUILD "Build Snappy for fuzzing." OFF)

option(SNAPPY_REQUIRE_AVX "Target processors with AVX support." OFF)

option(SNAPPY_REQUIRE_AVX2 "Target processors with AVX2 support." OFF)

option(SNAPPY_INSTALL "Install Snappy's header and library" ON)

include(TestBigEndian)
test_big_endian(SNAPPY_IS_BIG_ENDIAN)

include(CheckIncludeFile)
check_include_file("sys/mman.h" HAVE_SYS_MMAN_H)
check_include_file("sys/resource.h" HAVE_SYS_RESOURCE_H)
check_include_file("sys/time.h" HAVE_SYS_TIME_H)
check_include_file("sys/uio.h" HAVE_SYS_UIO_H)
check_include_file("unistd.h" HAVE_UNISTD_H)
check_include_file("windows.h" HAVE_WINDOWS_H)

include(CheckLibraryExists)
check_library_exists(z zlibVersion "" HAVE_LIBZ)
check_library_exists(lzo2 lzo1x_1_15_compress "" HAVE_LIBLZO2)
check_library_exists(lz4 LZ4_compress_default "" HAVE_LIBLZ4)

include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("/arch:AVX" HAVE_VISUAL_STUDIO_ARCH_AVX)
CHECK_CXX_COMPILER_FLAG("/arch:AVX2" HAVE_VISUAL_STUDIO_ARCH_AVX2)
CHECK_CXX_COMPILER_FLAG("-mavx" HAVE_CLANG_MAVX)
CHECK_CXX_COMPILER_FLAG("-mbmi2" HAVE_CLANG_MBMI2)
if(SNAPPY_REQUIRE_AVX2)
  if(HAVE_VISUAL_STUDIO_ARCH_AVX2)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:AVX2")
  endif(HAVE_VISUAL_STUDIO_ARCH_AVX2)
  if(HAVE_CLANG_MAVX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mavx")
  endif(HAVE_CLANG_MAVX)
  if(HAVE_CLANG_MBMI2)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mbmi2")
  endif(HAVE_CLANG_MBMI2)
elseif (SNAPPY_REQUIRE_AVX)
  if(HAVE_VISUAL_STUDIO_ARCH_AVX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:AVX")
  endif(HAVE_VISUAL_STUDIO_ARCH_AVX)
  if(HAVE_CLANG_MAVX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mavx")
  endif(HAVE_CLANG_MAVX)
endif(SNAPPY_REQUIRE_AVX2)

# Used by googletest.
#check_cxx_compiler_flag(-Wno-missing-field-initializers
#                        SNAPPY_HAVE_NO_MISSING_FIELD_INITIALIZERS)

include(CheckCXXSourceCompiles)
check_cxx_source_compiles("
int main() {
  return __builtin_expect(0, 1);
}" HAVE_BUILTIN_EXPECT)

check_cxx_source_compiles("
int main() {
  return __builtin_ctzll(0);
}" HAVE_BUILTIN_CTZ)

check_cxx_source_compiles("
__attribute__((always_inline)) int zero() { return 0; }

int main() {
  return zero();
}" HAVE_ATTRIBUTE_ALWAYS_INLINE)

check_cxx_source_compiles("
#include <tmmintrin.h>

int main() {
  const __m128i *src = 0;
  __m128i dest;
  const __m128i shuffle_mask = _mm_load_si128(src);
  const __m128i pattern = _mm_shuffle_epi8(_mm_loadl_epi64(src), shuffle_mask);
  _mm_storeu_si128(&dest, pattern);
  return 0;
}" SNAPPY_HAVE_SSSE3)

check_cxx_source_compiles("
#include <immintrin.h>
int main() {
  return _mm_crc32_u32(0, 1);
}" SNAPPY_HAVE_X86_CRC32)

check_cxx_source_compiles("
#include <arm_neon.h>
#include <arm_acle.h>
int main() {
  return __crc32cw(0, 1);
}" SNAPPY_HAVE_NEON_CRC32)

check_cxx_source_compiles("
#include <immintrin.h>
int main() {
  return _bzhi_u32(0, 1);
}" SNAPPY_HAVE_BMI2)

check_cxx_source_compiles("
#include <arm_neon.h>
int main() {
  uint8_t val = 3, dup[8];
  uint8x16_t v = vld1q_dup_u8(&val);
  vst1q_u8(dup, v);
  return 0;
}" SNAPPY_HAVE_NEON)

include(CheckSymbolExists)
check_symbol_exists("mmap" "sys/mman.h" HAVE_FUNC_MMAP)
check_symbol_exists("sysconf" "unistd.h" HAVE_FUNC_SYSCONF)

configure_file(
  "cmake/config.h.in"
  "${PROJECT_BINARY_DIR}/config.h"
)

# We don't want to define HAVE_ macros in public headers. Instead, we use
# CMake's variable substitution with 0/1 variables, which will be seen by the
# preprocessor as constants.
set(HAVE_SYS_UIO_H_01 ${HAVE_SYS_UIO_H})
if(NOT HAVE_SYS_UIO_H_01)
  set(HAVE_SYS_UIO_H_01 0)
endif(NOT HAVE_SYS_UIO_H_01)

if (SNAPPY_FUZZING_BUILD)
  if (NOT "${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
    message(WARNING "Fuzzing builds are only supported with Clang")
  endif (NOT "${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")

  if(NOT CMAKE_CXX_FLAGS MATCHES "-fsanitize=address")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
  endif(NOT CMAKE_CXX_FLAGS MATCHES "-fsanitize=address")

  if(NOT CMAKE_CXX_FLAGS MATCHES "-fsanitize=fuzzer-no-link")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=fuzzer-no-link")
  endif(NOT CMAKE_CXX_FLAGS MATCHES "-fsanitize=fuzzer-no-link")
endif (SNAPPY_FUZZING_BUILD)

configure_file(
  "snappy-stubs-public.h.in"
  "${PROJECT_BINARY_DIR}/snappy-stubs-public.h")

add_library(snappy "")
target_sources(snappy
  PRIVATE
    "snappy-internal.h"
    "snappy-stubs-internal.h"
    "snappy-c.cc"
    "snappy-sinksource.cc"
    "snappy-stubs-internal.cc"
    "snappy.cc"
    "${PROJECT_BINARY_DIR}/config.h"

  # Only CMake 3.3+ supports PUBLIC sources in targets exported by "install".
  $<$<VERSION_GREATER:CMAKE_VERSION,3.2>:PUBLIC>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/snappy-c.h>
    $<INSTALL_INTERFACE:include/snappy-c.h>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/snappy-sinksource.h>
    $<INSTALL_INTERFACE:include/snappy-sinksource.h>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/snappy.h>
    $<INSTALL_INTERFACE:include/snappy.h>
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/snappy-stubs-public.h>
    $<INSTALL_INTERFACE:include/snappy-stubs-public.h>
)
target_include_directories(snappy
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>
)
set_target_properties(snappy
  PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})

target_compile_definitions(snappy PRIVATE -DHAVE_CONFIG_H)
if(BUILD_SHARED_LIBS)
  set_target_properties(snappy PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif(BUILD_SHARED_LIBS)

ADD_LIBRARY(snappy-static STATIC
        snappy-c.cc
        snappy-c.h
        snappy-sinksource.cc
        snappy-sinksource.h
        snappy-stubs-internal.cc
        snappy-stubs-public.h
        snappy.cc
        snappy.h)

target_include_directories(snappy-static
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>
)

SET_TARGET_PROPERTIES(snappy-static PROPERTIES OUTPUT_NAME snappy)

if(SNAPPY_BUILD_TESTS OR SNAPPY_BUILD_BENCHMARKS)
  add_library(snappy_test_support "")
  target_sources(snappy_test_support
    PRIVATE
      "snappy-test.cc"
      "snappy-test.h"
      "snappy_test_data.cc"
      "snappy_test_data.h"
      "${PROJECT_BINARY_DIR}/config.h"
  )

  # Test files include snappy-test.h, HAVE_CONFIG_H must be defined.
  target_compile_definitions(snappy_test_support PUBLIC -DHAVE_CONFIG_H)

  target_link_libraries(snappy_test_support snappy)

  if(HAVE_LIBZ)
    target_link_libraries(snappy_test_support z)
  endif(HAVE_LIBZ)
  if(HAVE_LIBLZO2)
    target_link_libraries(snappy_test_support lzo2)
  endif(HAVE_LIBLZO2)
  if(HAVE_LIBLZ4)
    target_link_libraries(snappy_test_support lz4)
  endif(HAVE_LIBLZ4)

  target_include_directories(snappy_test_support
    BEFORE PUBLIC
      "${PROJECT_SOURCE_DIR}"
  )
endif(SNAPPY_BUILD_TESTS OR SNAPPY_BUILD_BENCHMARKS)

if(SNAPPY_BUILD_TESTS)
  enable_testing()

  # Prevent overriding the parent project's compiler/linker settings on Windows.
  set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
  set(install_gtest OFF)
  set(install_gmock OFF)
  set(build_gmock ON)

  # This project is tested using GoogleTest.
  #add_subdirectory("third_party/googletest")

  # GoogleTest triggers a missing field initializers warning.
  #if(SNAPPY_HAVE_NO_MISSING_FIELD_INITIALIZERS)
  #  set_property(TARGET gtest
  #      APPEND PROPERTY COMPILE_OPTIONS -Wno-missing-field-initializers)
  #  set_property(TARGET gmock
  #      APPEND PROPERTY COMPILE_OPTIONS -Wno-missing-field-initializers)
  #endif(SNAPPY_HAVE_NO_MISSING_FIELD_INITIALIZERS)

  add_executable(snappy_unittest "")
  target_sources(snappy_unittest
    PRIVATE
      "snappy_unittest.cc"
  )
  target_link_libraries(snappy_unittest snappy_test_support gmock_main gtest)

  add_test(
    NAME snappy_unittest
    WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"

=== debian/changelog ===
xmount (1.1.1-1) unstable; urgency=medium

  * [bd6709a] debian/control: update Homepage header for new upstream
    home. Thanks to Sven Geuer <sge@debian.org>
  * [cbcc98b] Update debian/watch for new upstream repository location
  * [4493222] New upstream version 1.1.1 (Closes: #1074150)
  * [204a746] Bump Standards-Version to 4.7.0
  * [b53b129] Update debian/copyright for recent upstream changes
  * [5926132] Update package description to better match with the one from
    upstream

 -- Michael Prokop <mika@debian.org>  Wed, 14 Aug 2024 14:04:06 +0200

=== debian/watch ===
version=4
opts="searchmode=plain" \
 https://code.sits.lu/foss/@PACKAGE@/tags?sort=updated_desc -/archive/v?\d[\d.]+/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate

## xmount 1.1.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(xmount C)

include(CheckIncludeFiles)
#include(CheckCSourceCompiles)

# For internal packaging only
#set(STATIC 1)
if(STATIC)
  set(STATIC_EWF 1)
  set(STATIC_AFF 1)
  set(STATIC_AFF4 1)
endif(STATIC)

if(STATIC_AFF)
  if(NOT LINUX_DIST)
    set(LINUX_DIST "debian7")
  else(NOT LINUX_DIST)
    if(NOT (LINUX_DIST STREQUAL "debian7" OR
            LINUX_DIST STREQUAL "rhel7"))
      message(FATAL_ERROR "Only Linux dists 'debian7' and 'rhel7' are supported!")
    endif(NOT (LINUX_DIST STREQUAL "debian7" OR
               LINUX_DIST STREQUAL "rhel7"))
  endif(NOT LINUX_DIST)
endif(STATIC_AFF)

add_definitions(-DXMOUNT_VERSION="1.1.1")

if(APPLE)
  # On OSx, do not try to find frameworks but only std headers / libraries
  set(CMAKE_FIND_FRAMEWORK "NEVER")
endif(APPLE)

# Make sure CMAKE_BUILD_TYPE is set
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
else(NOT CMAKE_BUILD_TYPE)
  if(NOT (CMAKE_BUILD_TYPE STREQUAL "Release" OR
          CMAKE_BUILD_TYPE STREQUAL "Debug"))
    message(FATAL_ERROR "Only build types 'Release' and 'Debug' are supported!")
  endif(NOT (CMAKE_BUILD_TYPE STREQUAL "Release" OR
             CMAKE_BUILD_TYPE STREQUAL "Debug"))
endif(NOT CMAKE_BUILD_TYPE)

# Add cmake_modules dir to CMAKE_MODULE_PATH
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake_modules/")

# Check required headers
check_include_files(stdlib.h HAVE_STDLIB_H)
check_include_files(stdio.h HAVE_STDIO_H)
check_include_files(stdint.h HAVE_STDINT_H)
check_include_files(stdarg.h HAVE_STDARG_H)
check_include_files(string.h HAVE_STRING_H)
check_include_files(errno.h HAVE_ERRNO_H)
check_include_files(fcntl.h HAVE_FCNTL_H)
check_include_files(dlfcn.h HAVE_DLFCN_H)
check_include_files(dirent.h HAVE_DIRENT_H)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(sys/ioctl.h HAVE_SYS_IOCTL_H)
check_include_files(sys/stat.h HAVE_SYS_STAT_H)
check_include_files(sys/types.h HAVE_SYS_TYPES_H)
check_include_files(linux/fs.h HAVE_LINUX_FS_H)
check_include_files(grp.h HAVE_GRP_H)
check_include_files(pwd.h HAVE_PWD_H)
check_include_files(pthread.h HAVE_PTHREAD_H)
check_include_files(time.h HAVE_TIME_H)
check_include_files(inttypes.h HAVE_INTTYPES_H)
check_include_files(byteswap.h HAVE_BYTESWAP_H)
check_include_files(endian.h HAVE_ENDIAN_H)
check_include_files(libkern/OSByteOrder.h HAVE_LIBKERN_OSBYTEORDER_H)

# Check for required libs
find_package(Threads REQUIRED)
if(NOT APPLE)
  find_package(LibFUSE REQUIRED)
else(NOT APPLE)
  # On OSx, search for osxfuse
  find_package(LibOSXFUSE REQUIRED)
endif(NOT APPLE)

# Generate config.h and add it's path to the include dirs
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# Add preprocessor definitions
add_definitions(-D_LARGEFILE64_SOURCE)
add_definitions(-D_FILE_OFFSET_BITS=64)
add_definitions(-D_GNU_SOURCE)
set(CMAKE_C_FLAGS "-fno-strict-aliasing -std=c99 -Wall")
set(CMAKE_C_FLAGS_RELEASE "-O2 ${CMAKE_C_FLAGS}")
set(CMAKE_C_FLAGS_DEBUG "-ggdb -O0 ${CMAKE_C_FLAGS}")

# Compile stuff in sub dirs
add_subdirectory(libxmount_input)
add_subdirectory(libxmount_morphing)
add_subdirectory(src)

# Install man page
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/xmount.1 DESTINATION share/man/man1)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -7,12 +7,20 @@
   link_directories(${LIBOSXFUSE_LIBRARY_DIRS})
 endif(NOT APPLE)
 
+if(CMAKE_THREAD_LIBS_INIT)
+  set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT})
+endif(CMAKE_THREAD_LIBS_INIT)
+
 set(LIBS ${LIBS} "dl")
 
 add_definitions(-DXMOUNT_LIBRARY_PATH="${CMAKE_INSTALL_PREFIX}/lib/xmount")
 
 add_executable(xmount xmount.c md5.c ../libxmount/libxmount.c)
 
+if(THREADS_HAVE_PTHREAD_ARG)
+  target_compile_options(xmount PUBLIC "-pthread")
+endif(THREADS_HAVE_PTHREAD_ARG)
+
 target_link_libraries(xmount ${LIBS})
 
 install(TARGETS xmount DESTINATION bin)

=== libxmount_input/libxmount_input_aff4/CMakeLists.txt ===
if(POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW) # CMake 3.0
endif(POLICY CMP0042)

project(libxmount_input_aff4 C)

if(NOT STATIC_AFF)
  include_directories(${LIBAFF4_INCLUDE_DIRS})
  set(LIBS ${LIBS} ${LIBAFF4_LIBRARIES})
else(NOT STATIC_AFF)
  include_directories(${CMAKE_CURRENT_SOURCE_DIR}/libaff4/src)

  set(LIBS ${LIBS} ${CMAKE_CURRENT_SOURCE_DIR}/libaff4/src/.libs/libaff4.a)
  set(LIBS ${LIBS} ${CMAKE_CURRENT_SOURCE_DIR}/libraptor2/src/.libs/libraptor2.a)
  set(LIBS ${LIBS} ${CMAKE_CURRENT_SOURCE_DIR}/libxml2/.libs/libxml2.a)
  set(LIBS ${LIBS} ${CMAKE_CURRENT_SOURCE_DIR}/libsnappy/build/libsnappy.a)

  if(NOT APPLE)
    set(LIBS ${LIBS} "-lstdc++ -lz -lm -ldl -llz4 -llzma")
  else(NOT APPLE)
    # As most of afflib4's deps on OSx come from MacPorts, better link in
    # everything statically
    set(LIBS ${LIBS} "/opt/local/lib/liblz4.a")
    set(LIBS ${LIBS} "/opt/local/lib/libz.a")
    set(LIBS ${LIBS} "-lstdc++")
  endif(NOT APPLE)
endif(NOT STATIC_AFF)

add_library(xmount_input_aff4 SHARED libxmount_input_aff4.c)

target_link_libraries(xmount_input_aff4 ${LIBS})

install(TARGETS xmount_input_aff4 DESTINATION lib/xmount)

=== debian/changelog ===
xmount (1.1.1+dfsg-1) unstable; urgency=medium

  * [1506596] Drop libxmount_input/*.tar.gz files from upstream tarballs
  * [810f7c9] New upstream version 1.1.1+dfsg (DFSG only)
    Thanks to Sven Geuer for review and feedback.

 -- Michael Prokop <mika@debian.org>  Tue, 20 Aug 2024 08:44:01 +0200

=== debian/control ===
Source: xmount
Section: admin
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders:
 Michael Prokop <mika@debian.org>,
Build-Depends: cmake,
               debhelper-compat (= 13),
               libafflib-dev,
               libbfio-dev,
               libewf-dev (>= 20080501),
               libfuse-dev (>= 2.7.1-2~bpo40+1),
               libgnutls28-dev,
               pkg-config,
               zlib1g-dev
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://www.sits.lu/xmount
Vcs-Browser: https://salsa.debian.org/pkg-security-team/xmount
Vcs-Git: https://salsa.debian.org/pkg-security-team/xmount.git

Package: xmount
Architecture: linux-any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: tool for crossmounting between disk image formats
 xmount allows you to convert on-the-fly between multiple input and
 output harddisk image formats. xmount creates a virtual file system
 using FUSE (Filesystem in Userspace) that contains a virtual
 representation of the input image.
 .
 The virtual representation can be in raw DD, Apple's Disk Image format
 (DMG), VirtualBox's virtual disk file format (VDI), Microsoft's Virtual
 Hard Disk Image format (VHD) or in VMware's VMDK file format.
 .
 Input images can be raw DD, EWF (Expert Witness Compression Format),
 AFF (Advanced Forensic Format), VDI (VirtualBox Virtual Disk Image) or
 QCOW (QEMU Copy On Write) files.
 .
 In addition, xmount also supports virtual write access to the output
 files that is redirected to a cache file. This makes it for example
 possible to boot acquired harddisk images using QEMU, KVM, VirtualBox,
 VWware or alike.

=== debian/watch ===
version=4
opts="searchmode=plain,dversionmangle=s/\+dfsg\d*//,repacksuffix=+dfsg" \
 https://code.sits.lu/foss/@PACKAGE@/tags?sort=updated_desc -/archive/v?\d[\d.]+/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate

## xmount 1.2.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,7 +24,7 @@
   endif(NOT LINUX_DIST)
 endif(STATIC_AFF)
 
-add_definitions(-DXMOUNT_VERSION="1.1.1")
+add_definitions(-DXMOUNT_VERSION="1.2.0")
 
 if(APPLE)
   # On OSx, do not try to find frameworks but only std headers / libraries

=== libxmount_input/libxmount_input_aff4/CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,9 @@
 
 if(NOT STATIC_AFF)
   include_directories(${LIBAFF4_INCLUDE_DIRS})
+  if (LIBAFF4_LDFLAGS)
+    link_directories(${LIBAFF4_LDFLAGS})
+  endif(LIBAFF4_LDFLAGS)
   set(LIBS ${LIBS} ${LIBAFF4_LIBRARIES})
 else(NOT STATIC_AFF)
   include_directories(${CMAKE_CURRENT_SOURCE_DIR}/libaff4/src)

=== debian/changelog ===
xmount (1.2.0+ds-1build1) questing; urgency=medium

  * Rebuild against latest fuse3

 -- Jeremy Bícha <jbicha@ubuntu.com>  Thu, 01 May 2025 14:48:46 -0400

xmount (1.2.0+ds-1) unstable; urgency=medium

  * [943cdad] New upstream version 1.2.0+ds
  * [2d905b7] Build-Depend on libfuse3-dev to migrate to fuse3
    (Closes: #1084480)

 -- Michael Prokop <mika@debian.org>  Fri, 15 Nov 2024 13:33:27 +0100

xmount (1.1.1+dfsg-2) unstable; urgency=medium

  * [3aeb359] debian/watch: use ds instead of the dfsg suffix. Thanks to
    Joao Eriberto Mota Filho for the suggestion
  * [c570b3f] Fix blhc issue + replace Build-Depends on pkg-config with
    pkgconf. Thanks to Joao Eriberto Mota Filho

 -- Michael Prokop <mika@debian.org>  Fri, 18 Oct 2024 19:42:05 +0200

## xmount 1.2.1%2Bds

=== libxmount_morphing/libxmount_morphing_unallocated/CMakeLists.txt ===
if(POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW) # CMake 3.0
endif(POLICY CMP0042)

project(libxmount_morphing_unallocated C)

add_library(xmount_morphing_unallocated SHARED libxmount_morphing_unallocated.c hfs_functions.c fat_functions.c ../../libxmount/libxmount.c)

install(TARGETS xmount_morphing_unallocated DESTINATION lib/xmount)

=== debian/control ===
--- 
+++ 
@@ -9,9 +9,9 @@
                libafflib-dev,
                libbfio-dev,
                libewf-dev (>= 20080501),
-               libfuse-dev (>= 2.7.1-2~bpo40+1),
+               libfuse3-dev,
                libgnutls28-dev,
-               pkg-config,
+               pkgconf,
                zlib1g-dev
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
